
package jworms.game;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.DataOutputStream;
import java.awt.geom.Point2D;
import java.awt.*;

public class GameFieldModifier extends GameObject{
// static
  /** ID for the object class. */
  private static int classID = 0;
  public int getClassID() { return classID; }
  public void setClassID(int id) { classID = id; }

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // register class id
    GameField.registerClass(new GameFieldModifier(true, null, 0, 0, 0, null));
  }

// non static
  /** GameField. */
  private GameField gameField = null;
  /** Center of the explosion. */
  private Point position = null;
  /** Radius of the explosion. */
  private int maxRadius = 0;
  /** Explosion shape as polygon. */
  private Polygon explosionPolygon = null;

  public GameFieldModifier(boolean isHologram, GameField gameField, int x, int y, int maxRadius, Polygon explosionPolygon){
    super(isHologram);

    this.gameField = gameField;
    position = new Point(x, y);
    this.maxRadius = maxRadius;
    this.explosionPolygon = explosionPolygon;

    if(!isHologram) hasAction = true;
  }

  public Point2D.Float getPosition(){
    return new Point2D.Float(position.x, position.y);
  }

  public void doAction(){
    GameFieldUtil.doExplosion(gameField, position.x, position.y, maxRadius, explosionPolygon);
  }

  public void doMove(){
  }

  public void draw(){
  }

  public void dispose(){
  }

// network
  public GameObject create(GameField gameField, DataInputStream in) throws IOException{
    GameFieldModifier gameFieldModifier = new GameFieldModifier(true, gameField, 0, 0, 0, new Polygon());
    gameFieldModifier.recieveUpdate(in);
    return gameFieldModifier;
  }

  public void sendUpdate(DataOutputStream out) throws IOException{
    out.writeInt(position.x);
    out.writeInt(position.y);
    out.writeInt(maxRadius);

    out.writeShort(explosionPolygon.npoints);
    for(int point_nr = 0; point_nr < explosionPolygon.npoints; point_nr++){
      out.writeShort(explosionPolygon.xpoints[point_nr]);
      out.writeShort(explosionPolygon.ypoints[point_nr]);
    }
  }

  public void recieveUpdate(DataInputStream in) throws IOException{
    position.x = in.readInt();
    position.y = in.readInt();
    maxRadius = in.readInt();

    explosionPolygon.reset();
    int npoints = in.readShort();
    for(int point_nr = 0; point_nr < npoints; point_nr++){
      explosionPolygon.addPoint(in.readShort(), in.readShort());
    }
  }
}
