
package jworms.game;

import jworms.openGL.BitmapFont;
import jworms.openGL.SmallTexture;
import org.lwjgl.Display;
import org.lwjgl.opengl.GL;

/**
 * Renders player information.
 */
public class PlayerInformationUI{
// static
  /** Bar texture. */
  private static SmallTexture barTexture = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      barTexture = new SmallTexture("images/menu/bar/bar_blue.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in PlayerInformationUI during loading images.");
      e.printStackTrace();
    }
  }

// non static
  /** Player. */
  private Player player = null;

  /**
   * Creates a PlayerInformationUI for the given player.
   *
   * @param player player
   */
  public PlayerInformationUI(Player player){
    this.player = player;
  }

  public void draw(BitmapFont font){
    String stringHealth = "Health";
    String stringEnergy = "Energy";

    int stringWidth = Math.max(font.getWidth(stringHealth), font.getWidth(stringEnergy));

    int y = Display.getHeight() - 95;
    font.drawString(stringHealth, 25, y);
    drawBar(35 + stringWidth, y + 5, (int) (player.getHealth() * 100));

    y += font.getHeight();
    font.drawString(stringEnergy, 25, y);
    drawBar(35 + stringWidth, y + 5, (int) player.getPosition().getY() / 10);
  }

  /**
   * Draws the bar at the given position.
   *
   * @param x x
   * @param y y
   */
  private void drawBar(int x, int y, int barSize){
    int textureWidth = barTexture.getImage().getWidth();
    int borderSize = 8;

    int textureX[] = {0, borderSize, textureWidth - borderSize, textureWidth};
    int screenX[] = {0, borderSize, borderSize + barSize, 2 * borderSize + barSize};

    //barTexture.draw(x, y);
    barTexture.drawHorizontalQuads(x, y, textureX, screenX);
  }
}
