
package jworms.game.explosion;

import jworms.game.GameField;
import jworms.openGL.SmallTexture;
import org.lwjgl.opengl.GL;

import java.awt.geom.Point2D;

public class ExplosionFireball extends ExplosionCloud{
// static
  /** Fireball texture */
  private static SmallTexture texture = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      texture = new SmallTexture("images/explosion/fireball.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in ExplosionFireball during loading images.");
      e.printStackTrace();
    }
  }

// non static
  /**
   * Creates an explosion fireball.
   *
   * @param gameField game field
   * @param position position
   * @param motion motion
   */
  public ExplosionFireball(GameField gameField, Point2D.Float position, Point2D.Float motion){
    super(gameField, position, motion);

    maxLife = 1.5f;
    scaleFactor = 1;
    alphaFactor = 1;
  }

  /**
   * Returns the texture.
   *
   * @return texture
   */
  public SmallTexture getTexture(){
    return texture;
  }
}
