
package jworms.game.weapons;

import jworms.game.GameField;
import jworms.game.GameObject;
import jworms.game.Player;
import jworms.openGL.SmallTexture;
import org.lwjgl.opengl.GL;

import java.awt.*;

public class AK47 extends DesertEagle{
// static
  /** Texture for the weapon. */
  private static SmallTexture weaponTexture = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      weaponTexture = new SmallTexture("images/weapons/ak47/ak47.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in AK47 during loading images.");
      e.printStackTrace();
    }
  }

// non static
  /** Accuracy of the shoot. */
  private float accuracy = 0;

  public AK47(GameField gameField){
    super(gameField);

    // Center of the weapon in texture coordinates
    relativeWeaponCenter = new Point(26, 16);
    // Position of the weapon center relative to the position of the Player
    relativeWeaponCenterPosition = new Point(24, 22);
    // Distance between the weapon center and the barrel center
    gripBarrelDistance = -3;

    // Damage radius of shoots
    damageRadius = 5;
  }

  public SmallTexture getTexture(){
    return weaponTexture;
  }

  protected float getShootAngle(Player player){
    return player.getAimingAngle() + ((float) Math.random() - 0.5f) / 10 * accuracy;
  }

  public void loop(){
    super.loop();

    // accuracy gets better
    accuracy = Math.max(accuracy - 0.025f, 0.1f);
  }

  public GameObject fireWeapon(Player player, GameField gameField){
    GameObject bullet = super.fireWeapon(player, gameField);

    // loops till next shoot
    loopsTillReady = 7;

    // accuracy gets worse
    accuracy = Math.min(accuracy + 0.5f, 1.3f);

    return bullet;
  }
}
