
package jworms.game.weapons;

import jworms.game.GameField;
import jworms.openAL.OpenALWave;
import jworms.openGL.SmallTexture;
import jworms.util.MathUtil;
import org.lwjgl.opengl.GL;
import org.lwjgl.openal.AL;

public class BulletUI extends BallUI{
// static
  /** Texture. */
  private static SmallTexture texture = null;

  /** Hit sound. */
  private static OpenALWave soundFire = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      texture = new SmallTexture("images/weapons/deserteagle/bullet.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in GrenadeUI during loading images.");
      e.printStackTrace();
    }

    // load sound
    try{
      soundFire = OpenALWave.create("sounds/MachineGunFire.wav");
    } catch(Exception e){
      System.out.println("Error in GrenadeUI during loading sound.");
      e.printStackTrace();
    }
  }

// non static
  /** The associated bullet. */
  private Bullet bullet = null;

  /**
   * Creates a UI for the given Bullet.
   *
   * @param bullet bullet
   * @param gameField game field
   */
  public BulletUI(Bullet bullet, GameField gameField){
    super(bullet, gameField, 1, 2);

    this.bullet = bullet;

    // play sound
    if(bullet.getPosition() != null && soundSource.bind()){
      if(soundSource.getPropi(AL.AL_SOURCE_STATE) == AL.AL_PLAYING) soundSource.stop();

      soundSource.setPos(bullet.getPosition().x, bullet.getPosition().y, 0);
      soundSource.setPropf(AL.AL_GAIN, 1);
      soundSource.play(soundFire);
    }
  }

  public SmallTexture getTexture(){
    return texture;
  }

  public OpenALWave getSoundHit(){
    return null;
  }
}
