
package jworms.game.weapons;

import jworms.game.GameField;
import jworms.openAL.OpenALWave;
import jworms.openGL.SmallTexture;
import org.lwjgl.opengl.GL;
import org.lwjgl.openal.AL;

public class RocketUI extends BallUI{
// static
  /** Texture. */
  private static SmallTexture texture = null;

  /** Hit sound. */
  private static OpenALWave soundFire = null;

  /**
   * Loads textures and sound.
   */
  public static void init(){
    // load images
    try{
      texture = new SmallTexture("images/weapons/rocketlauncher/missle.png", GL.GL_LINEAR);
    } catch(Exception e){
      System.out.println("Error in RocketUI during loading images.");
      e.printStackTrace();
    }

    // load sound
    try{
      soundFire = OpenALWave.create("sounds/MachineGunFire.wav");
    } catch(Exception e){
      System.out.println("Error in RocketUI during loading sound.");
      e.printStackTrace();
    }
  }

// non static
  /** The associated rocket. */
  private Rocket rocket = null;

  /**
   * Creates a UI for the given Bullet.
   *
   * @param rocket rocket
   * @param gameField game field
   */
  public RocketUI(Rocket rocket, GameField gameField){
    super(rocket, gameField, 1, 2);

    alpha = 1;
    this.rocket = rocket;

    // play sound
    if(rocket.getPosition() != null && soundSource.bind()){
      if(soundSource.getPropi(AL.AL_SOURCE_STATE) == AL.AL_PLAYING) soundSource.stop();

      soundSource.setPos(rocket.getPosition().x, rocket.getPosition().y, 0);
      soundSource.setPropf(AL.AL_GAIN, 1);
      soundSource.play(soundFire);
    }
  }

  public SmallTexture getTexture(){
    return texture;
  }

  public OpenALWave getSoundHit(){
    return null;
  }
}
