
package jworms.openGL;

import java.awt.*;

public class SmallTexturePart{
  /** SmallTexture. */
  public SmallTexture smallTexture = null;

  /** Location of the part. */
  public Rectangle part = null;

  /**
   * Extracts a part of a small texture.
   *
   * @param smallTexture SmallTexture
   * @param x x
   * @param y y
   * @param width width
   * @param height height
   */
  public SmallTexturePart(SmallTexture smallTexture, int x, int y, int width, int height){
    this.smallTexture = smallTexture;
    part = new Rectangle(x, y, width, height);
  }

  /**
   * Draws the texture.
   *
   * @param x x
   * @param y y
   * @param scaleHorizontal horizontal stretch factor
   * @param scaleVertical vertical stretch factor
   * @param angle angle (0..360)
   */
  public void draw(int x, int y, float scaleHorizontal, float scaleVertical, float angle){
    smallTexture.draw(x, y, part, scaleHorizontal, scaleVertical, angle);
  }
}
