
package jworms.test;

import jworms.openAL.OpenALListener;
import jworms.openAL.OpenALSource;
import jworms.openAL.OpenALUtils;
import jworms.openAL.OpenALWave;
import org.lwjgl.openal.AL;

public class TestAL{
  public static void main(String[] args) throws InterruptedException{
    OpenALUtils.alInit();

    OpenALListener.setPos(0, 0, 100);

    // (load) some waves
    OpenALWave explosion2 = OpenALWave.create("sounds/Explosion.wav");
    OpenALWave explosion2_test = OpenALWave.create("sounds/Explosion.wav");
    OpenALWave mineArm = OpenALWave.create("sounds/GrenadeImpact.wav");
//    OpenALWave twang2 = OpenALWave.create("sounds/Twang2.wav");

    // load all waves
    OpenALWave.alGenWaves();
    System.out.println("explosion2 = " + explosion2);
    System.out.println("explosion2_test = " + explosion2_test);
    System.out.println("mineArm = " + mineArm);
//    System.out.println("twang2 = " + twang2);

    // create source1
    OpenALSource source1 = new OpenALSource();
    if(source1.bind()){
      System.out.println("source1 = " + source1);
      // setup source1
//      source1.setPropf(AL.AL_REFERENCE_DISTANCE, 50.0f);
//      source1.setPropf(AL.AL_ROLLOFF_FACTOR, 0.05f);
      source1.setPos(0, -20, 0);

      // play explosion2 from source1
      source1.play(mineArm);

      // wait until wave playing stoped
      while(source1.getPropi(AL.AL_SOURCE_STATE) == AL.AL_PLAYING) Thread.sleep(100);
    }

    System.out.println("source1 done");


    // create source2
    OpenALSource source2 = new OpenALSource();
    if(source2.bind()){
      System.out.println("source2 = " + source2);
      // setup source2
//      source2.setPropf(AL.AL_REFERENCE_DISTANCE, 50.0f);
//      source2.setPropf(AL.AL_ROLLOFF_FACTOR, 0.05f);
      source2.setPropf(AL.AL_PITCH, 0.5f);
      source2.setPos(0, 20, 0);

      // play mineArm from source2
      source2.play(explosion2);

      // wait until wave playing stoped
      while(source2.getPropi(AL.AL_SOURCE_STATE) == AL.AL_PLAYING) Thread.sleep(100);
    }


    if(source1.bind()){
      System.out.println("source1 = " + source1);
      // play explosion2 from source1
      source1.play(mineArm);

      // wait until wave playing stoped
      while(source1.getPropi(AL.AL_SOURCE_STATE) == AL.AL_PLAYING) Thread.sleep(100);
    }

    // free source1
    source1.dispose();
    // free source2
    source2.dispose();

    // free wave buffers
    OpenALWave.alDeleteWaves();
    OpenALUtils.alExit();
  }
}
