
package jworms.test;

import jworms.network.UDPNetworkListener;
import jworms.network.UDPNetwork;
import jworms.network.GameInfo;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.DataOutputStream;

public class UDPNetworkTestJoiner implements UDPNetworkListener {
// static
  public static void main(String[] args) {
    UDPNetworkTestJoiner joiner = new UDPNetworkTestJoiner();
  }

// non static
  private UDPNetwork udpNetwork;
  private GameInfo gameInfo;

  public UDPNetworkTestJoiner(){
    udpNetwork = new UDPNetwork();
    udpNetwork.addUDPNetworkListener(this);
    // other looks for games
    udpNetwork.lookForGames();

    try{
      Thread.sleep(2000);
    } catch(InterruptedException e){
      e.printStackTrace();
    }

    try{
      udpNetwork.joinGame(gameInfo);
    } catch(IOException e){
      System.out.println("Error joining the game: " + e.getMessage());
    }

    try{
      Thread.sleep(2000);
    } catch(InterruptedException e){
      e.printStackTrace();
    }

    try{
      int i = 1400;
      byte b[] = new byte[10000];
      while(true){
        DataOutputStream out = udpNetwork.getPacketOutputStream();
        out.writeInt(i);
        out.write(b, 0, i);
        udpNetwork.sendPacket();
        System.out.println("send: " + i);
        try{
          Thread.sleep(10);
        }catch(Exception e){}
      }
    } catch(IOException e){
      System.out.println("Error : " + e.getMessage());
    }
  }

// network communication
  public void gameJoined(int id) {
    System.out.println("joined the game!!! My id is " + id);
  }

  public void receivePacket(DataInputStream in) {
  }

  public void foundGame(GameInfo gameInfo) {
    System.out.println("Game: " + gameInfo);
    this.gameInfo = gameInfo;
  }
}
